#-*- coding:utf-8 -*-
"""  Simple Zope3 Database Adapter for Postgres (psycopg2)
$Id$
"""
import pymssql
from zope.rdb import ZopeDatabaseAdapter, parseDSN

class MSSQLAdapter(ZopeDatabaseAdapter):

    def _connection_factory(self):    
        info = parseDSN(self.dsn)

        connection = pymssql.connect(host='%s:%s' % (info['host'], info['port']),
                                     user=info['username'],
                                     password=info['password'],
                                     database=info['dbname'])
                                     
                                     
        
        return connection
    

from decimal import Decimal
import datetime
import types
import string
import time

def myquote(x):
    if type(x) == types.StringType:
        x = "'" + string.replace(str(x), "'", "''") + "'"
    elif type(x) in (types.IntType, types.LongType, types.FloatType):
        pass
    elif x is None:
        x = 'NULL'
    elif isinstance(x, Decimal):
        x = x
    elif isinstance(x, datetime.datetime):
        x = "'" + str(x)[:19] + "'"
    elif isinstance(x, datetime.date):
        x = "'%s'" % x
    elif isinstance(x, bool):
        x = x and 1 or 0
    elif hasattr(x, '__pg_repr__'):
        x = x.__pg_repr__()
    else:
        print '\n HHHHHHH', x
        print "didn't like " + x + " " + str(type(x))
        
    return x


    
pymssql._quote = myquote


